Subject: bug#24070: LaTeX mode doesn't load in 11.89.4

From: Mosè Giordano <[email-masked]>
Date: Wed, 27 Jul 2016 00:35:55 +0200

Hi Stefan,

2016-07-26 19:44 GMT+02:00 Stefan Monnier <[email-masked]>:
>> Still, this workaround seem a little odd to me.  First, It seems odd that I
>> can't start AUCTeX "when I want", i.e., by using the line (load "auctex.el"
>> nil t t), even though this worked for me in previous versions of auctex
>> (11.89 and 11.88).
>
> Packaging in ELPA aims to follow the way packages bundled with Emacs are
> handled, such that they're not "started" automatically, but they are
> automatically setup so that you can "start" them by just invoking their
> functionality (e.g. loading a .tex file).
>
>> Second, it also seems a little odd that I can't do something like
>> (require 'auctex) or (use-package auctex), even though I can load all
>> my other 30+ packages that way.  The concept of having nothing in my
>> .emacs and the package still being expected to work definitely
>> confused me at the beginning.
>
> The only standard/supported way to setup an ELPA package in general is
> to load its <pkg>-autoloads.el file (that's what package-initialize does
> usually).  In practice, from what you say, loading <pkg>.el tends to
> work as well, but that's mostly an accident.
>
> This said, AUCTeX has historically been enabled by (load "tex-site") or
> (load "auctex"), so it would make sense for AUCTeX's package to support
> this.  I thought it worked, but your bug-report shows that it doesn't.
>
> The (untested) patch/hack below might help cases like yours.
> I'm not sure if AUCTeX's maintainers want to go that route or would
> prefer to just detect the case and emit a warning instead to try and
> help people follow the standard installation method.

Sorry, I don't quite understand the purpose of the patch.   Is it
intended for the ELPA version of AUCTeX or for the upstream package?
The fact that the package is against tex-site.el in ELPA makes me
think it's for the ELPA version of AUCTeX.  In that case, I don't have
any objection against trying to make the installation easier for users
(even if I don't know how the current installation method via ELPA can
be defined as "hard").

Bye,
Mosè